<script lang="ts">
	import { getSocket } from '$lib/services/socket';
	import type { Socket } from 'socket.io-client';
	import { onMount } from 'svelte';

	let name = '';
	let socket: Socket | null = null;

	onMount(() => {
		name = localStorage.getItem('name') || '';
		socket = getSocket();
	});

	function createGame() {
		if (!socket) return;
		socket.emit('create game');
		socket.on('game created', (gameId: string) => {
			window.location.href = `/game/${gameId}`;
		});
	}

	$: if (name) {
		localStorage.setItem('name', name);
	}
</script>

<svelte:head>
	<title>Chifoumi - Play Rock-Paper-Scissors Online</title>
	<meta
		name="description"
		content="Chifoumi is a rock-paper-scissors app where you can play against your friends online or against a computer."
	/>
</svelte:head>

<section>
	<h1>Chifoumi</h1>
	<h2>Welcome to Chifoumi Online!</h2>
	<p>
		Chifoumi is a fun and exciting online version of the classic Rock-Paper-Scissors game. Test your
		strategy and luck by playing against your friends or challenge our computer opponent.
	</p>

	<div class="card">
		<input class="input-name" type="text" placeholder="Enter your name" bind:value={name} />
		<button class="link online" on:click={createGame}>Create a game</button>
		<a class="link computer" href="/computer">Play against the computer</a>
	</div>

	<h2>How to Play:</h2>
	<ol>
		<li>Enter your name</li>
		<li>Click on the button "Create a game"</li>
		<li>Invite a friend to join you for a friendly match or play against our computer AI.</li>
		<li>Play!</li>
	</ol>

	<h3>Ready to Play?</h3>
  <p>Get started now and experience the nostalgia and excitement of Rock-Paper-Scissors right here, online! Challenge your friends or have a quick solo match against the computer. Have fun and may the best hand win!</p>
</section>

<style>
	section {
		display: flex;
		flex-direction: column;
		justify-content: center;
		align-items: center;
		flex: 0.6;
	}
	h1 {
		font-family: 'YoungSerif';
		letter-spacing: 0.1rem;
		font-size: calc(3rem + 5vw);
		margin: 0 0 1.5rem 0;
	}
	h2 {
		margin: 0.5rem 0;
	}
	p {
		text-align: center;
		text-wrap: balance;
		margin: 0 0 1.5rem 0;
	}
	ol {
		padding: revert;
	}

	.card {
		width: 100%;
		max-width: 400px;
		display: flex;
		flex-direction: column;
		gap: 1.2rem;
		padding: 1rem;
		margin: 1.5rem 0;

		border-radius: 1rem;
		background-color: var(--color-bg-2);
	}

	.input-name {
		padding: 0.5rem;
		border-radius: 0.5rem;
		border: 1px solid var(--color-bg-3);
		outline: none;
	}
	.input-name:focus {
		border: 1px solid var(--color-primary);
	}

	.link {
		all: unset;
		padding: 0.5rem 1rem;
		border-radius: 0.5rem;

		text-align: center;
		text-decoration: none;
		cursor: pointer;

		transition: all 0.2s ease-in-out;
	}
	.online {
		font-size: 2rem;
		background-color: var(--color-primary);
	}
	.online:hover {
		background-color: var(--color-primary-dark);
	}

	.computer {
		font-size: 1.5rem;
		background-color: var(--color-bg-3);
	}
	.computer:hover {
		background-color: hsl(203deg 21% 68% / 80%);
	}

	@media screen and (max-width: 500px) {
		h1 {
			font-size: calc(2rem + 5vw);
		}
		.online {
			font-size: 1.5rem;
		}
		.computer {
			font-size: 1rem;
		}
	}
</style>
